# Subscription

> see https://aka.ms/autorest

This is the AutoRest configuration file for Subscription.



---
## Getting Started
To build the SDK for Subscription, simply [Install AutoRest](https://aka.ms/autorest/install) and in this folder, run:

> `autorest`

To see additional help and options, run:

> `autorest --help`
---

## Configuration

## Suppression
``` yaml
directive:
  - suppress: R2059
```


### Basic Information
These are the global settings for the Subscription API.

``` yaml
openapi-type: arm
tag: package-2018-11-preview
```


### Tag: package-2018-11-preview

These settings apply only when `--tag=package-2018-03-preview` is specified on the command line.

``` yaml $(tag) == 'package-2018-11-preview'
input-file:
- Microsoft.Subscription/preview/2018-11-01-preview/subscriptions.json
- Microsoft.Subscription/stable/2016-06-01/subscriptions.json
title: SubscriptionClient
description: The subscription client
```

### Tag: package-2018-03-preview

These settings apply only when `--tag=package-2018-03-preview` is specified on the command line.

``` yaml $(tag) == 'package-2018-03-preview'
input-file:
- Microsoft.Subscription/preview/2018-03-01-preview/subscriptions.json
- Microsoft.Subscription/stable/2016-06-01/subscriptions.json
title: SubscriptionClient
description: The subscription client
```

### Tag: package-2017-11-preview

These settings apply only when `--tag=package-2017-11-preview` is specified on the command line.

``` yaml $(tag) == 'package-2017-11-preview'
input-file:
- Microsoft.Subscription/preview/2017-11-01-preview/subscriptionDefinitions.json
```

---
# Code Generation


## Swagger to SDK

This section describes what SDK should be generated by the automatic system.
This is not used by Autorest itself.

``` yaml $(swagger-to-sdk)
swagger-to-sdk:
  - repo: azure-sdk-for-go
  - repo: azure-sdk-for-python
  - repo: azure-sdk-for-node
  - repo: azure-sdk-for-js
```


## Python

These settings apply only when `--python` is specified on the command line.
Please also specify `--python-sdks-folder=<path to the root directory of your azure-sdk-for-python clone>`.
Use `--python-mode=update` if you already have a setup.py and just want to update the code itself.

``` yaml $(python)
python-mode: create
python:
  azure-arm: true
  license-header: MICROSOFT_MIT_NO_VERSION
  payload-flattening-threshold: 2
  namespace: azure.mgmt.subscription
  package-name: azure-mgmt-subscription
  clear-output-folder: true
```
``` yaml $(python) && $(python-mode) == 'update'
python:
  no-namespace-folders: true
  output-folder: $(python-sdks-folder)/azure-mgmt-subscription/azure/mgmt/subscription
```
``` yaml $(python) && $(python-mode) == 'create'
python:
  basic-setup-py: true
  output-folder: $(python-sdks-folder)/azure-mgmt-subscription
```

## Go

See configuration in [readme.go.md](./readme.go.md)

## Java

These settings apply only when `--java` is specified on the command line.
Please also specify `--azure-libraries-for-java-folder=<path to the root directory of your azure-libraries-for-java clone>`.

``` yaml $(java)
azure-arm: true
fluent: true
namespace: com.microsoft.azure.management.subscription
license-header: MICROSOFT_MIT_NO_CODEGEN
payload-flattening-threshold: 1
output-folder: $(azure-libraries-for-java-folder)/azure-mgmt-subscription
```

### Java multi-api

``` yaml $(java) && $(multiapi)
batch:
  - tag: package-2017-11-preview
```

### Tag: package-2017-11-preview and java

These settings apply only when `--tag=package-2017-11-preview --java` is specified on the command line.
Please also specify `--azure-libraries-for-java=<path to the root directory of your azure-sdk-for-java clone>`.

``` yaml $(tag) == 'package-2017-11-preview' && $(java) && $(multiapi)
java:
  namespace: com.microsoft.azure.management.subscription.v2017_11_01_preview
  output-folder: $(azure-libraries-for-java-folder)/subscription/resource-manager/v2017_11_01_preview
regenerate-manager: true
generate-interface: true
```


